import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class NeedForSkillWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class NeedForSkillWorld extends World
{
    private int score = 0;
    private int lives = 4;

    private StatusBoard scoreBoard;

    /**
     * Constructor for objects of class NeedForSkillWorld.
     * 
     */
    public NeedForSkillWorld()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        //false helping to use -negv numbers of the world 
        super(600, 400, 1,false); 
        setPaintOrder(Player.class,EnemyVehicle.class,OilSlick.class,pedestrian.class,Rocket.class,Endline.class,roadLines.class);
        
        addObject (new Player(), 300, 375);
         if(Greenfoot.getRandomNumber(100)<10)
        {
         addObject(new pedestrian(),Greenfoot.getRandomNumber(320)+140,20);
        }
        
        for(int i=0;i<3;i++)
        {
            
         addObject (new EnemyVehicle (),Greenfoot.getRandomNumber(270)+170, -35);
         Greenfoot.delay (50);
         
        }

        scoreBoard = new StatusBoard ();
        addObject (scoreBoard, 30, 385);
        scoreBoard.updateStatus (score, lives);
        
        
        prepare();
    }

    public void started ()
    {
        Greenfoot.playSound("Sound Effects (Car Driving Sound Effects).mp3");
        Greenfoot.delay (200);
    }   

    public void increaseScore ()
    {
        score = score + 1;
        scoreBoard.updateStatus (score, lives);
    }

    public int getScore ()
    {
        return score;
    }

    public void loseLife()
    {
        lives --;
        scoreBoard.updateStatus (score, lives);
        if (lives == 0)
        {
            Greenfoot.stop();
        }
    }

    public int getLives()
    {
        return lives;
    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        roadLines roadlines = new roadLines();
        addObject(roadlines, 312, 43);
        roadLines roadlines2 = new roadLines();
        addObject(roadlines2, 312, 108);
        roadLines roadlines3 = new roadLines();
        addObject(roadlines3, 315, 179);
        roadLines roadlines4 = new roadLines();
        addObject(roadlines4, 317, 254);
        roadLines roadlines5 = new roadLines();
        addObject(roadlines5, 322, 312);
        roadLines roadlines6 = new roadLines();
        addObject(roadlines6, 326, 359);
        roadlines.setLocation(304, 38);
        roadlines2.setLocation(305, 108);
        roadlines3.setLocation(305, 179);
        roadlines3.setLocation(306, 179);
        roadlines4.setLocation(307, 248);
        roadlines5.setLocation(308, 312);
        roadlines6.setLocation(308, 370);
        removeObject(roadlines6);
        roadlines5.setLocation(305, 324);
        roadlines4.setLocation(304, 249);
        roadlines3.setLocation(303, 179);
        roadlines2.setLocation(302, 108);
        roadlines.setLocation(302, 38);
        Tracklength tracklength = new Tracklength();
        addObject(tracklength, 25, 209);
        DriveProgress driveprogress = new DriveProgress();
        addObject(driveprogress, 32, 351);
        driveprogress.setLocation(27, 354);
        driveprogress.setLocation(26, 354);
        driveprogress.setLocation(25, 355);
        driveprogress.setLocation(25, 308);
    }
}
